//This file contain the main program for TAG3P
//Programmed by NXH
//#include<conio.h>//Delete this line if you are in Unix
#include<iostream.h>
#include<stdlib.h>
#include<string.h>
#include<stdio.h>
#include<math.h>
#include<assert.h>
#include "gconst.h"
#include "random.h"
#include "stree.h"
#include "lexicon.h"
#include "adtable.h"
#include  "dtree.h"
#include "genetic.h"
//#include "mulplex.h"
//#include "bdtree1.h"
//#include "bdtree2.h"
#include "symregr.h"
//#include "evenpg.h"
int generation,gen=0;
//individual bestsofar;
individual *bestcurrent;
double *average;
//*****************************************************
//This Function initializes for the program           *
//*****************************************************
void Init()
{
 //Initialize global variables
 //Loading Elementary trees and Adjoining Table
  LoadEtree();
  GetERconst=ERGenerate;//DefaultConstant
 //Initialize population
  poplen=500;
  oldpop=new individual[poplen];assert(oldpop!=NULL);
  newpop=new individual[poplen];assert(newpop!=NULL);
 //Initialize Probabilities
  pcross=0.9;
  preplace=0.1;
  pdelete=0;
  pinsert=0;
  pmutate=0.0;
  prep=0.0;
  ptran=0;
//Initializes satistics
  ncross=0;
  nreplace=0;
  ninsert=0;
  ndelete=0;
  nmutate=0;
  nrep=0;
  ntran=0;
//Number of generations
  generation=51;
  bestcurrent=new individual[generation];assert(bestcurrent!=NULL);
  average=new double[generation];assert(average!=NULL);
//Some global variables
   SuccPredicate=FALSE;
  _cut=TRUE;
//Set up fitness cases
  SetFitCase();
}
//**************************************
//Compute the fitness of an individual *
//**************************************
double ComputeIndividualRF(individual v)
{
 stree s;
 double f;
 s=Decode(v,FALSE);
 f=ComputeRF(s);
 DeleteTree(s);
 return f;
}

//********************************************************************
//Marking and pruning non-fitness contributing parts of an individual*
//********************************************************************
SIZE _activesize;
double _variance,_rawfitness;
void OldMarkingDtree1(dnode *t,individual &v) //use for sub-code of type 1 only (i.e complete subtree)
{
 stree s;
 double f;
 dnode *p;
 SIZE size1;
 if(t)
 {
  //compute the size
  size1=GetSizeDNode(t,TRUE);
  if(_activesize-size1>=MINSIZE)//only do the marking if the result bigger than MIN SIZE
   {
    t->id=-t->id;//temporary marked off
    f=ComputeIndividualRF(v); //compute the new fitness
   
   // cout<<endl<<"Fitness:"<<f;
   // cout<<endl<<"Active size:"<<_activesize;
    if(fabs(f-_rawfitness)<= _variance) //if the change is insignificant
       _activesize-=size1;
    else
      { 
       t->id=-t->id; 
       //try subtrees
       p=t->children;
      while(p)
       {
        OldMarkingDtree1(p,v);
        p=p->sibling;
       }
      } 
   }
    
  else
   {
    p=t->children;
    while(p)
     {
       OldMarkingDtree1(p,v);
       p=p->sibling;
     }
   }
 }
}
void MarkingDtree1(dnode *t,individual &v) //use for both types of sub-code added in version 3.1
{
 stree s;
 double f;
 dnode *p;
 SIZE size1,size2;
 BOOL type1OK, type2OK;
 if(t)
 {
  //compute the size
  size1=GetSizeDNode(t,TRUE);
  //first try the subcode of type1
 type1OK=FALSE;
 type2OK=FALSE;
 if(_activesize-size1>=MINSIZE)//only do the marking if the result bigger than MIN SIZE
   {
    t->id=-t->id;//temporary marked off
    f=ComputeIndividualRF(v); //compute the new fitness
    if(fabs(f-_rawfitness)<= _variance) //if the change is insignificant
     {  
     _activesize-=size1;
      type1OK=TRUE;
     } 
    else
      t->id=-t->id; //turns it back on
    }
 if(!type1OK) //if type1 subcode is not marked then try type2
 { 
  if(t!=v.chrom) //not the root
   if(RootAdjoined(t))
    {
     p=t->children;
     while(p->sibling) p=p->sibling;
     size2=GetSizeDNode(p,TRUE);
     size2=size1-size2;
     if(_activesize-size2>=MINSIZE)
      {
       t->id=-(t->id+numetree); //temporarily marked for subcode type 2
       f=ComputeIndividualRF(v);
       if(fabs(f-_rawfitness)<=_variance)//if the change is insinificant
        {
         _activesize-=size2;
         type2OK=TRUE;
        }
       else
        t->id=-(t->id+numetree);
      } 
    } 
     
//try the children
   if(!type2OK) //
   {
    p=t->children;
    while(p)
     {
       MarkingDtree1(p,v);
       p=p->sibling;
     }
    }
   else 
    {
     p=t->children;
     while(p->sibling) p=p->sibling;
     MarkingDtree1(p,v);
     }
  }
 
 }
}
void OldDeleteIntron(individual &v) //delete introns as subcode of type 1 (complete sub-tree) only
{
 _variance=0.0;//subject to change
 _activesize=v.size;
_rawfitness=ComputeIndividualRF(v);
 OldMarkingDtree1(v.chrom,v);
 cout <<endl<<"Active size:"<<_activesize;
 PruneDNode(v.chrom,NULL);
 v.size=_activesize;
 v.branch=GetAVGDNode(v.chrom);
}
void DeleteIntron(individual &v) //delete introns as subcodes of type 1 and 2
{
 _variance=0.0;//subject to change
 _activesize=v.size;
_rawfitness=ComputeIndividualRF(v);
 MarkingDtree1(v.chrom,v);
// cout <<endl<<"Active size:"<<_activesize;
 PruneDNode(v.chrom,NULL);
 v.size=_activesize;
 v.branch=GetAVGDNode(v.chrom);
}

//*******************************************************************************
//Marking and extracting the most effective (destructive) parts of an individual*
//*******************************************************************************
dnode *_subcode;
double _rawfitness2,_mloss;
BOOL  _effordes,_subcodetype;
void OldMarkingDtree2(dnode *t,dnode *parent,individual &v) //marking subcode of type 1 only 
{
 stree s;
 double f;
 dnode *p;
 SIZE size1;
 if(parent) //excluding the root
 {
    t->id=-t->id;//temporary marked off
    f=ComputeIndividualRF(v); //compute the new fitness
     if(_effordes) //detect the most effective
      {   
       if(fabs(f-_rawfitness2)<_mloss)  
        {
         _subcode=t;
         _mloss=fabs(f-_rawfitness2);
        }
      }
     else
       if(fabs(f-_rawfitness2)>_mloss)
        {
         _subcode=t;
         _mloss=fabs(f-_rawfitness2);
        }
    t->id=-t->id;  
    p=t->children;
    while(p)
     {
       OldMarkingDtree2(p,t,v);
       p=p->sibling;
     }
  }
}
void MarkingDtree2(dnode *t,dnode *parent,individual  &v) //marking sub code of type1 and type 2
{
 stree s;
 double f;
 dnode *p;
 SIZE size1;
 if(parent) //excluding the root
 {
    t->id=-t->id;//temporary marked off
    f=ComputeIndividualRF(v); //compute the new fitness
     if(_effordes) //detect the most effective
      {   
       if(fabs(f-_rawfitness2)<_mloss ) 
        {
         _subcode=t;
         _mloss=fabs(f-_rawfitness2);
         _subcodetype=TRUE; //subcode type1
        }
      }
     else
       if(fabs(f-_rawfitness2)>_mloss)//detect the most destructive
        {
         _subcode=t;
         _mloss=fabs(f-_rawfitness2);
          _subcodetype=TRUE; //subcode type1
        }
    t->id=-t->id;  
//try sub-code type 2
    if(RootAdjoined(t))
    {
     t->id=-(t->id+numetree);
     f=ComputeIndividualRF(v);
     if(_effordes)//detect the most effecitive 
       {
        if(fabs(f-_rawfitness2)<_mloss)
         {
          _subcode=t;
          _mloss=fabs(f-_rawfitness2);
          _subcodetype=FALSE;//subcode type2 
         }
       }
      else
      if(fabs(f-_rawfitness2)>_mloss) //dtect the most destructive
       {
        _subcode=t;
        _mloss=fabs(f-_rawfitness2);
        _subcodetype=FALSE;
       } 
     t->id=-(t->id+numetree); 
    } 
      
    p=t->children;
    while(p)
     {
       MarkingDtree2(p,t,v);
       p=p->sibling;
     }
  }
}
dnode *OldSubCodeDetect(individual &v,BOOL type) //subcode of type 1 only
{
 if(type)//find the most effective subcode 
  _mloss=999999999.99;
 else
  _mloss=-999999999.99;
 _rawfitness2=ComputeIndividualRF(v);
 _effordes=type;
 _subcode=NULL;
  OldMarkingDtree2(v.chrom,NULL,v);
 return _subcode;  
}
dnode *SubCodeDetect(individual &v,BOOL type, BOOL &subcodetype) //subcode of type 1 and type 2
{
 if(type)//find the most effective subcode 
  _mloss=999999999.99;
 else
  _mloss=-999999999.99;
 _rawfitness2=ComputeIndividualRF(v);
 _effordes=type;
 _subcode=NULL;
  MarkingDtree2(v.chrom,NULL,v);
 subcodetype=_subcodetype;
 return _subcode;  
}
void GreedyIndividual(individual &p,int times)
{
 individual q;
 int i;
for(i=0;i<times;i++)
{
q=CopyIndividual(p,TRUE);
if(Flip(0.5))
 Insert(q,1,FALSE); 
else
 Delete(q,1);
q.fitness=NUMFITCASE-ComputeIndividualRF(q);
if(q.fitness<p.fitness)
  {
   DeleteDNode(p.chrom);
   p=CopyIndividual(q,FALSE);
  }
 } 
}
void Greedy(int times)
{
 int i,j;
 individual p;
for (i=0;i<poplen;i++)
 {
  for(j=0;j<times;j++)
  {
   p=CopyIndividual(oldpop[i],TRUE);
   if(Flip(0.5))
    Insert(p,1,FALSE);
   else
    Delete(p,1);
   p.fitness=ComputeIndividualRF(p);
   if (p.fitness<oldpop[i].fitness)
   {
    DeleteDNode(oldpop[i].chrom);
    oldpop[i]=CopyIndividual(p,FALSE);
   }
  }
 }
}
void ComputeFitness()
{
 int i,j, pos;
 stree s;
 individual t;
 double min,sum=0;
 //First Compute Raw fitness
 for(i=0;i<poplen;i++)
    oldpop[i].fitness=ComputeIndividualRF(oldpop[i]);
  
//local search
 Greedy(0);
 //Second Compute standardized fitness
 //for(i=0;i<poplen;i++)
  //  oldpop[i].fitness=(double) NUMFITCASE-oldpop[i].fitness;
 //Find the best of the current population
   min=oldpop[0].fitness;
   pos=0;
   sum=0;
   for(i=1;i<poplen;i++)
   {
    if (oldpop[i].fitness<min)
    {
      min=oldpop[i].fitness;
      pos=i;
    }
    sum+=oldpop[i].fitness;
    }
//   GreedyIndividual(oldpop[pos],500);
 //copy the best and average
   bestcurrent[gen]=CopyIndividual(oldpop[pos],TRUE);
   average[gen]=sum/poplen;
  if(bestcurrent[gen].fitness==0)
      SuccPredicate=TRUE;      
 //Third Compute Adjusted fitness
   AdjustFitness();
 //Finally Compute nomarlized fitness
   NormalizeFitness();
}

void Evolution()
{
 int i,j,l,k;
 individual *temp,parent1,parent2;
 stree s;
 //Initialize a population
 RampInit(2,10,0.0);
 gen=0;
 while((gen<generation) && !SuccPredicate)
 {
    //cout<<"GENERATION "<<gen<<endl;
	ComputeFitness();
    cout<<"generation..."<<gen<<endl;//"...Best Fitness:"<<bestcurrent[gen].fitness;
  //for(i=0;i<poplen;i++)
   //DisplayIndividual(oldpop[i]);
//if(gen%5==1)  
 //for(i=0;i<poplen;i++)
 //  if(Flip(0.4))
 //   DeleteIntron(oldpop[i]);
   l=0;
  while(l<poplen)
   {
    i=TourSelect(3);
    j=TourSelect(3);
    parent1=CopyIndividual(oldpop[i],TRUE);
    parent2=CopyIndividual(oldpop[j],TRUE);
   if(Flip(pcross))
   {
    if (OldSubTreeSwap2(parent1,parent2,newpop[l],newpop[l+1],FALSE,0,0.9))
      ncross++;
    else
     {
      newpop[l]=CopyIndividual(parent1,FALSE);
      newpop[l+1]=CopyIndividual(parent2,FALSE);
     }
   }
    else
     {
      newpop[l]=CopyIndividual(parent1,FALSE);
      newpop[l+1]=CopyIndividual(parent2,FALSE);
     }
//mutation test
 if(Flip(preplace))
  if(ReplaceSubTree2(newpop[l],0,FALSE,TRUE,5,0.9))
    nreplace++;
  if(Flip(preplace))
   if(ReplaceSubTree2(newpop[l+1],0,FALSE,TRUE,5,0.9))
    nreplace++;
  
//Point replacment
/*  if(Flip(preplace))
   if(PointReplace(newpop[l]))
    nreplace++;
  if(Flip(preplace))
    if(PointReplace(newpop[l+1]))
     nreplace++;*/
//replication test
  if(Flip(prep))
   if(Replicate(newpop[l],TRUE))
    nrep++;
  if(Flip(prep))
   if(Replicate(newpop[l+1],TRUE))
    nrep++;  
    l+=2;
  }
  gen++;
  for(k=0;k<poplen;k++)
   DeleteDNode(oldpop[k].chrom);
  temp=oldpop;
  oldpop=newpop;
  newpop=temp;
 }
}

main(int argc,char *argv[])
{
 int i,pos;
 double min;
 long seed;
 stree s,s1;
 //char a;
 InitRanGen();//success key: 12306-tam06,12307-tam07,12309-tam09
 //cout<<endl<<"Enter Seed:";
 //cin>>seed;
 Set_Seed(atol(argv[1]));//some (in many) other keys for successful induction of
 Init();        //the target function are 12347-12352,12371-12374,...
 Evolution();
 cout<<endl<<"Last generation:"<<gen-1<<endl;
 //cin>>a;
 cout<<endl<<"Best Individuals:";
 for(i=0;i<gen;i++)
  {
   cout<<endl<<"Generation:"<<i<<endl;
   DisplayIndividual(bestcurrent[i]);
   cout<<endl<<"**********************";
 //  getch();
  }
 min=bestcurrent[0].fitness;
 pos=0;
 for(i=1;i<gen;i++)
   if(bestcurrent[i].fitness<min)
    {
     min=bestcurrent[i].fitness;
     pos=i;
    }
  cout<<endl<<"The best found at generation:"<<"("<<pos<<")";
  DeleteIntron(bestcurrent[pos]);
  DisplayIndividual(bestcurrent[pos]);
/*  s1=Decode(bestcurrent[pos],FALSE);
  s.root=Stree2ParseTree(s1.root);
  s.foot=NULL;
  cout<<endl<<"Corresponding Parse Tree:";
  Display(s);*/
  cout<<endl<<"Number of crossover:"<<ncross;
  cout<<endl<<"Number of Replacement:"<<nreplace;
  cout<<endl<<"Number of Replication:"<<nrep;
 // getch();//Delete this line if you are in Unix*/

}





